
; 32-bit code, 64-bit x 64-bit multiply-to-divide test program

; by DednDave 10-2009

;------------------------------------------------------------------------------

        INCLUDE \masm32\include\masm32rt.inc

;------------------------------------------------------------------------------

;adjust this value so the process uses about 25% or less of CPU time

PauseReset   EQU 70000

;------------------------------------------------------------------------------

        .CONST

        ALIGN   4

Divisor      dd 1000000000

;-----------------------------------------------

        .DATA

        ALIGN   4

MultiplierLo dd 36B4A597h
MultiplierHi dd 89705F41h

Shift        dd 29

PauseCount   dd PauseReset

;-----------------------------------------------

        .DATA?

        ALIGN   4

DividendLo   dd ?
DividendHi   dd ?

QuotientLo   dd ?
QuotientHi   dd ?

TestCmpLo    dd ?
TestCmpHi    dd ?

PassLo       dd ?
PassHi       dd ?

NextPointLo  dd ?
NextPointHi  dd ?

Step         dd ?

;------------------------------------------------------------------------------

        .CODE

_main   PROC

        mov     ecx,64

M2DTst: push    ecx
        call    MTest
        mov     eax,MultiplierLo
        mov     edx,MultiplierHi
        shr     edx,1
        rcr     eax,1
        mov     MultiplierLo,eax
        mov     MultiplierHi,edx
        dec dword ptr Shift
        pop     ecx
        dec     ecx
        jnz     M2DTst

        inkey
        exit

_main   ENDP

;------------------------------------------------------------------------------

MTest   PROC

;test all values where the high dword is 0000_0000

        xor     eax,eax
        mov     DividendHi,eax
        mov     QuotientHi,eax
        mov     TestCmpHi,eax

MTest0: xor     ecx,ecx
        mov     DividendLo,eax
        call    Div64
        mov     QuotientLo,eax
        mov     edi,Divisor
        xor     edx,edx
        mov     eax,DividendLo
        div     edi
        mov     TestCmpLo,eax
        cmp     eax,QuotientLo
        jnz     MTest6

        mov     eax,DividendLo
        inc     eax
        jnz     MTest0

;test all values just before/after quotient rollover and
;where the low dword (after m2d increment) is 0 or FFFF_FFFF

        mov     ecx,eax               ;ecx = 0
        inc     eax
        mov     ebx,eax               ;ebx = 1
        add     eax,QuotientLo
        mul     edi
        sub     eax,ebx
        sbb     edx,ecx
        mov     ecx,edx
        sub     edi,ebx
        mov     Step,edi

MTest1: mov     DividendLo,eax
        mov     DividendHi,ecx
        call    Div64
        mov     QuotientLo,eax
        mov     QuotientHi,edx
        mov     edi,Divisor
        xor     edx,edx
        mov     eax,DividendHi
        div     edi
        mov     TestCmpHi,eax
        mov     eax,DividendLo
        div     edi
        mov     TestCmpLo,eax
        cmp     eax,QuotientLo
        jnz     MTest4

        mov     eax,TestCmpHi
        cmp     eax,QuotientHi
        jnz     MTest4

        mov     eax,DividendLo
        mov     ecx,DividendHi
        mov     PassLo,eax
        mov     PassHi,ecx
        mov     ebx,NextPointLo
        mov     esi,NextPointHi
        mov     edx,ebx
        or      edx,esi
        jnz     MTest2

        sub     edi,Step
        mov     Step,edi
        add     eax,edi
        jnc     MTest1

        dec     edx                   ;edx = FFFF_FFFF
        inc     ecx
        mov     NextPointLo,eax
        dec     edx                   ;edx = FFFF_FFFE
        mov     NextPointHi,ecx
        xchg    eax,edx
        dec     ecx
        jmp     MTest1

MTest2: xor     edx,edx
        dec     edx                   ;edx = FFFF_FFFF
        cmp     eax,edx
        jz      MTest3

        inc     eax                   ;eax = FFFF_FFFF
        jmp     MTest1

MTest3: cmp     esi,edx
        jz      MTest7

        xor     eax,eax
        mov     NextPointLo,eax
        mov     NextPointHi,eax
        xchg    eax,ebx
        mov     ecx,esi
        jmp     MTest1

;failure found: return to the last passing value
;and step by one to find the lowest failure dividend

MTest4: mov     eax,PassLo
        mov     ecx,PassHi

MTest5: xor     edx,edx
        inc     edx
        add     eax,edx
        dec     edx
        adc     ecx,edx
        mov     DividendLo,eax
        mov     DividendHi,ecx
        call    Div64
        mov     QuotientLo,eax
        mov     QuotientHi,edx
        mov     edi,Divisor
        xor     edx,edx
        mov     eax,DividendHi
        div     edi
        mov     TestCmpHi,eax
        mov     eax,DividendLo
        div     edi
        mov     TestCmpLo,eax
        cmp     eax,QuotientLo
        jnz     MTest6

        mov     eax,TestCmpHi
        cmp     eax,QuotientHi
        jnz     MTest6

        mov     eax,DividendLo
        mov     ecx,DividendHi
        jmp     MTest5

;fail report

MTest6: print   chr$('Multiplier: ')
        mov     eax,MultiplierHi
        print   uhex$(eax),'_'
        mov     eax,MultiplierLo
        print   uhex$(eax),32,32
        print   chr$('Mult Divisor: 2^')
        mov     eax,Shift
        add     eax,64
        print   str$(eax),32,32
        print   chr$('Fail: ')
        mov     eax,DividendHi
        print   uhex$(eax),'_'
        mov     eax,DividendLo
        print   uhex$(eax),13,10
        ret

;test all values where the high dword is FFFF_FFFF

MTest7: mov     edi,Divisor
        xor     eax,eax
        mov     edx,eax
        dec     eax
        mov     DividendHi,eax
        div     edi
        mov     TestCmpHi,eax
        mov     NextPointHi,edx
        xor     eax,eax

MTest8: mov     DividendLo,eax
        xor     ecx,ecx
        dec     ecx
        call    Div64
        mov     QuotientLo,eax
        mov     QuotientHi,edx
        mov     edi,Divisor
        mov     eax,DividendLo
        mov     edx,NextPointHi
        div     edi
        mov     TestCmpLo,eax
        cmp     eax,QuotientLo
        jnz     MTest6

        mov     eax,TestCmpHi
        cmp     eax,QuotientHi
        jnz     MTest6

        mov     eax,DividendLo
        inc     eax
        jnz     MTest8

;pass report

        print   chr$('Multiplier: ')
        mov     eax,MultiplierHi
        print   uhex$(eax),'_'
        mov     eax,MultiplierLo
        print   uhex$(eax),32,32
        print   chr$('Mult Divisor: 2^')
        mov     eax,Shift
        add     eax,64
        print   str$(eax),32,32
        print   chr$('Pass: ')
        mov     eax,0FFFFFFFFh
        print   uhex$(eax),'_'
        mov     eax,0FFFFFFFFh
        print   uhex$(eax),13,10
        ret

MTest   ENDP

;------------------------------------------------------------------------------

        ALIGN   16

Div64   PROC

;64x64 multiply-to-divide

;Call With: ECX:EAX = Dividend
;  Returns: EDX:EAX = Quotient

        dec dword ptr PauseCount
        jz      Div64d

Div64a: xor     ebx,ebx
        inc     ebx
        add     eax,ebx
        dec     ebx
        mov     edx,MultiplierLo     ;partial multiplier lo
        adc     ecx,ebx
        jc      Div64e

        mov     esi,eax
        mul     edx                  ;partial multiply to divide - multiplier lo X dividend lo
        mov     edi,edx              ;save partial result
        mov     eax,MultiplierHi     ;partial multiplier hi
        push    ebx                  ;save a zero for later
        mul     esi                  ;partial multiply to divide - multiplier hi X dividend lo
        mov     esi,ebx              ;zero in esi
        add     edi,eax              ;partial sum
        adc     ebx,edx              ;partial sum
        mov     eax,MultiplierLo     ;partial multiplier lo
        adc     esi,esi              ;partial sum
        mul     ecx                  ;partial multiply to divide - multiplier lo X dividend hi
        add     eax,edi              ;partial sum
        pop     edi                  ;recall zero in edi
        adc     ebx,edx              ;partial sum
        adc     edi,esi              ;partial sum
        mov     eax,MultiplierHi     ;partial multiplier hi
        mul     ecx                  ;partial multiply to divide - multiplier hi X dividend hi
        add     eax,ebx              ;complete the sum
        adc     edx,edi              ;complete the sum

Div64b: mov     ecx,Shift
        or      ecx,ecx
        js      Div64f

        jz      Div64c

        shrd    eax,edx,cl           ;adjust the low quotient
        shr     edx,cl               ;adjust the high quotient

Div64c: ret

;let the CPU up for air once in a while

Div64d: mov dword ptr PauseCount,PauseReset
        push    ecx
        push    eax
        INVOKE  Sleep,1
        pop     eax
        pop     ecx
        jmp     Div64a

Div64e: mov     eax,MultiplierHi
        xchg    eax,edx
        jmp     Div64b

Div64f: neg     ecx
        shld    edx,eax,cl
        shl     eax,cl
        ret

Div64   ENDP

;------------------------------------------------------------------------------

        END     _main

